/*** THIS PROGRAM AIMS AT BUILDING THE ECONOMETRIC DATASET BY MERGING THE MAIN DATA 
WITH THE GENERALIZED RESIDUALS  OBTAINED FROM FIRST-STAGE REGRESSIONS 
OF ENDOGENOUS REGRESSORS ON INSTRUMENTS ***/

DM 'CLEAR LOG; CLEAR OUTPUT;';

libname TEMP 'C:\xxx';
libname final 'C:\zzz';

options linesize = 132;
options pagesize = 72;
options notes;
          
PROC IMPORT OUT= TEMP.Resids_first_step 
            DATAFILE= "C:\resids.dta" 
            DBMS=STATA REPLACE;

RUN;

proc sort data=TEMP.STATA_BASE_Q3_CHOCS; by num_entr date; run;
proc sort data=TEMP.Resids_first_step; by num_entr date; run;

data TEMP.STATA_BASE_Q3_CHOCS; merge TEMP.STATA_BASE_Q3_CHOCS TEMP.Resids_first_step; by num_entr date;run;

data final.GAUSS_estim_small_stats(keep= num_entr siren etabl date annee mois ape_ec poids_eff 
ind_10 ind_11 ind_13 ind_15 ind_16 ind_17 ind_18 
ind_20 ind_21 ind_22 ind_23 ind_24 ind_25 ind_26 ind_27 ind_28 ind_29 
ind_30 ind_31 ind_32 ind_33 
DUR_1-DUR_14 DUR15_24 DUR25_00 MOIS_1-MOIS_12 
id_tva1 id_tva2 id_euro id_euro2 
trim1 trim2 trim3 trim4 Y_1999-Y_2009 
evprpf delta_p y_null
pr_rm pr_rm1 pr_rmc pr_rmc1 pr_rmc0 prod prod1 prodc prodc1 prodc0 wage wage1 wagec wagec1 wagec0 txipp2 ppi1 ppic ppic1 ppic0 
rpr_rm rpr_rm1 rpr_rmc rpr_rmc1 rpr_rmc0 rprod rprod1 rprodc rprodc1 rprodc0 rwage rwage1 rwagec rwagec1 rwagec0 rw_lshk rw_perm
rppi1 rppic rppic1 rppic0 
iip_lshk iip_sshk wag_lshk wag_sshk pro_lshk pro_sshk ipp_lshk ipp_sshk
iip_perm l1_iip_perm prod_perm l1_prod_perm ipp_perm l1_ipp_perm w_perm
compet q03 q10 lib10 q17a 
m_d_spi m_d_pip m_d_wag m_d_pro);
set TEMP.STATA_BASE_Q3_CHOCS;
rename evprmp= pr_rm;
rename evprmp_L1= pr_rm1;
rename cum_evprmp = pr_rmc;
rename cum_evprmp_L1 = pr_rmc1;
rename cum_evprmp_L0 = pr_rmc0;

rename evpro= prod;
rename evpro_L1= prod1;
rename cum_evpro = prodc;
rename cum_evpro_L1 = prodc1;
rename cum_evpro_L0 = prodc0;

rename isalmtot2= wage;
rename isalmtot2_L1= wage1;
rename cum_isalmtot = wagec;
rename cum_isalmtot_L1 = wagec1;
rename cum_isalmtot_L0 = wagec0;

rename txipp2_L1= ppi1;
rename cum_ipp2 = ppic;
rename cum_ipp2_L1 = ppic1;
rename cum_ipp2_L0 = ppic0;
run;


proc sort data=final.GAUSS_estim_small_stats; by num_entr annee mois; run;

proc means data=final.GAUSS_estim_small_stats; run;
