/*** THIS PROGRAM AIMS AT COMPUTING THE DESCRIPTIVE STATISTICS 
IN TABLES 4 AND 5 OF THE PAPER   ***/

DM 'CLEAR LOG; CLEAR OUTPUT;';

libname TEMP 'C:\xxx';
libname final 'C:\zzz';

options linesize = 100;
options pagesize = 72;



/** computation of statistics for the econometric database **/
data temp.base_stat_des; set final.gauss_estim_small_stats;

price_change =(evprpf ne 0);
price_increase =(evprpf > 0);
price_decrease =(evprpf < 0);

iip_change =(pr_rm ne 0);
iip_increase =(pr_rm > 0);
iip_decrease =(pr_rm < 0);

prod_change =(prod ne 0);
prod_increase =(prod > 0);
prod_decrease =(prod < 0);

wage_change= (wage ne 0);
wage_increase= (wage > 0);
wage_decrease= (wage < 0);

cost_change = (iip_change+wage_change >0); 
envir_change = (iip_change+wage_change+prod_change >0); 

trim = (mois in (1,2,3)) + 2*(mois in (4,5,6)) + 3*(mois in (7,8,9)) + 4*(mois in (10,11,12));
run;

title 'Table 4 - frequency of changes from the econometric database';
proc freq data = temp.base_stat_des;
tables evprpf ;
tables pr_rm ;
tables wage;
tables prod ;
tables txipp2 ;
run;
  

title 'Table 5 - price changes conditional to changes in input costs and production';
proc freq data=temp.base_stat_des; 
tables price_change*iip_change;
tables price_change*wage_change;
tables price_change*prod_change;
run;

title 'Table 5 - price changes conditional to large shocks on input costs and production';
proc freq data=temp.base_stat_des; 
tables price_change*iip_lshk;
tables price_change*wag_lshk;
tables price_change*pro_lshk;
run;

title 'Table 5 - price changes conditional to permanent shocks on input costs and production';
proc freq data=temp.base_stat_des; 
tables price_change*iip_perm;
tables price_change*prod_perm;
run;


