new;
closeall;
cls;

          /* PROGRAM TO ESTIMATE RANDOM EFFECTS INFLATED ORDERED PROBIT MODELS */

library cml;
#include cml.ext;

clearg no_con, gop_flex;
clearg date_id;

                        /* CHANGE DIRECTORIES AS APPROPRIATE BELOW */

#include e:\mark\gauss\procs\iop_RE_sim.prc; 
#include e:\mark\gauss\procs\hitmiss.prc; 

cmlset;


/* SET DIRECTORIES */

cdo 		= cdir(0);
load path 	= ^cdo;
save path 	= ^cdo;

			/* LOAD RAW DATA AND NAME VARIABELS */

                        /* CHANGE DIRECTORY/FILE NAME AS APPROPRIATE BELOW */

infile1	= "e:\\mark\\data\\BoF\\BoF_JoAE_R1";

open fh = ^infile1 varindxi;
vnames 	= getname(infile1);

xx 		= readr(fh,rowsf(fh));  
n       = rows(xx);

y       = xx[.,iEVPRPF];
y       = y - minc(y);                                      
capJ    = maxc(y) - minc(y) + 1;

idvec   = xx[.,iNUM_ENTR];

date_id	= xx[.,iDATE];


/* SET NO_CON = 0, FOR CONSTANT IN OP MODEL; AND = 1 FOR AN EXTRA BOUNDARY PARAMETER */

no_con = 0;


/* SET GOP_FLEX = 1; FOR FLEXIBLE GOP MODELS; = 0 FOR ONLY ONE SET OF PARAMETERS */

gop_flex = 0;


/* VARIBLES COMMON TO X (PROBIT) AND Z (ORDERED PROBIT) EQUATIONS */


xandz   = xx[.,iY_NULL
iID_TVA1
iID_TVA2
iID_EURO
iID_EURO2
iY_1999
iY_2000
iY_2001
iY_2002
iY_2003
iY_2004
iY_2005
iY_2006
iY_2007
iY_2008
iIND_10
iIND_11
iIND_13
iIND_15
iIND_16
iIND_17
iIND_18
iIND_20
iIND_21
iIND_22
iIND_23
iIND_24
iIND_25
iIND_26
iIND_27
iIND_28
iIND_29
iIND_30
iIND_31
iIND_32]~ones(rows(xx),1);

let xandzvars   = Y_NULL
ID_TVA1
ID_TVA2
ID_EURO
ID_EURO2
Y_1999
Y_2000
Y_2001
Y_2002
Y_2003
Y_2004
Y_2005
Y_2006
Y_2007
Y_2008
IND_10
IND_11
IND_13
IND_15
IND_16
IND_17
IND_18
IND_20
IND_21
IND_22
IND_23
IND_24
IND_25
IND_26
IND_27
IND_28
IND_29
IND_30
IND_31
IND_32
CON;


/* VARIBLES IN SPLITTING EQUATION ONLY */

xonly       = xx[.,iIIP_LSHK
iWAG_LSHK
iPRO_LSHK
iIPP_LSHK
iIIP_PERM
iW_PERM
iPROD_PER
iIPP_PERM
iM_D_PIP
iM_D_WAG
iM_D_PRO
iM_D_SPI
iCOMPET
iDUR_1
iDUR_2
iDUR_3
iDUR_4
iDUR_5
iDUR_6
iDUR_7
iDUR_8
iDUR_9
iDUR_10
iDUR_11
iDUR_12
iDUR_13
iDUR_14
iDUR15_24
iMOIS_1
iMOIS_2
iMOIS_3
iMOIS_4
iMOIS_5
iMOIS_6
iMOIS_7
iMOIS_8
iMOIS_9
iMOIS_10
iMOIS_11
iRW_PERM
iRW_LSHK];

let xvars   = IIP_LSHK
WAG_LSHK
PRO_LSHK
IPP_LSHK
IIP_PERM
W_PERM
PROD_PER
IPP_PERM
M_D_PIP
M_D_WAG
M_D_PRO
M_D_SPI
COMPET
DUR_1
DUR_2
DUR_3
DUR_4
DUR_5
DUR_6
DUR_7
DUR_8
DUR_9
DUR_10
DUR_11
DUR_12
DUR_13
DUR_14
DUR15_24
MOIS_1
MOIS_2
MOIS_3
MOIS_4
MOIS_5
MOIS_6
MOIS_7
MOIS_8
MOIS_9
MOIS_10
MOIS_11
RW_PERM
RW_LSHK;

/*
xandz   = ones(rows(xx),1);
let xandzvars   = CON;
*/

/* VARIBLES IN ORDERED PROBIT EQUATION */

zonly       = xx[.,iPR_RM
iPR_RMC0
iWAGE
iWAGEC0
iPROD
iPRODC0
iTXIPP2
iPPIC0
iRPR_RM
iRPR_RMC0
iRWAGE
iRWAGEC0
iRPROD
iRPRODC0
iRPPIC0];	
	
let zvars   =  PR_RM
PR_RMC0
WAGE
WAGEC0
PROD
PRODC0
TXIPP2
PPIC0
RPR_RM
RPR_RMC0
RWAGE
RWAGEC0
RPROD
RPRODC0
RPPIC0;							
					

//xz      = xandz~zonly;                    @ STACK DATA IN ORDER: COMMON, X ONLY, Z ONLY @
xz      = xandz~xonly~zonly;                    @ STACK DATA IN ORDER: COMMON, X ONLY, Z ONLY @


/* DELETE ANY MISSING VALUES */

yxzall  = packr(y~idvec~xz);
y 	    = yxzall[.,1];
idvec   = yxzall[.,2];
xzall   = yxzall[.,3:cols(yxzall)];

/*
cx = corrx(wxzall);stop;
cx = vec(cx);
sortc(cx,1);stop;
*/

/* THE CONTIGID ID VECTOR MUST BE CONTIGUOUS! AND START AT 1 */

idcontig = 1;
irep = 2;
do while irep le rows(y); 
	if idvec[irep] eq idvec[irep-1];
		idcontig = idcontig|idcontig[irep-1];
	else;
		idcontig = idcontig|(idcontig[irep-1]+1);
	endif;
    irep = irep + 1;
endo;

capJ	= maxc(y) - minc(y) + 1;
kall    = cols(xzall);
N_all   = rows(y);
N 	    = maxc(idcontig);

			/* NAME X'S &amp; Y'S &amp; SAVE */

let yvars       = PCHANGE3;
wxzvars          = xandzvars|xvars|zvars;
//wxzvars          = xandzvars|zvars;
let id          = id;
let date_name	= date;
yxzvars         = yvars|id|wxzvars;

data            = y~idcontig~xzall;

            if not saved(data,"BoFdatR1",yxzvars);
                errorlog "Disk full";stop;
                end;
            endif;


    /* DESCRIPTIVE STATS */

{ vnam,mean,var,std,min,max,valid,mis } = dstat("BoFdatR1",yxzvars);


    /* CONSTRUCT INDICATOR VARIABLES FOR j=J */

d_ij	= zeros(N_all,1);

for jrep (0,capJ-1,1);
	d_ij = d_ij~(y .eq jrep);
endfor;

d_ij = d_ij[.,2:cols(d_ij)];
phat = meanc(d_ij);


/* NEED AN INDICATOR VARIABLE TO LET PROC KNOW WHAT X'S ARE FOR PROBIT MODEL &amp; WHAT Z'S ARE FOR ORDERED MODEL */

/* specifies x's corresponding to "wxzvars" above - ignoring y and same for z's in ordered model */

x_vec                    = zeros(1,cols(xzall));                                     /* probit model */
x_vec[1:cols(xandz)]     = ones(1,cols(xandz));
x_vec[cols(xandz)+1:cols(xandz)+cols(xonly)] = ones(1,cols(xonly));

z_vec    = zeros(1,cols(xzall));	                                                    /* ordered model */
z_vec[1:cols(xandz)]     = ones(1,cols(xandz));
z_vec[cols(xandz)+cols(xonly)+1:cols(xandz)+cols(xonly)+cols(zonly)] = ones(1,cols(zonly));
//z_vec[cols(xandz)+1:cols(xandz)+cols(zonly)] = ones(1,cols(zonly));


// wxz      = wxandz~xandz~xandw~xonly~zonly;                    @ STACK DATA IN ORDER: COMMON, X ONLY, Z ONLY @

w_vec    = zeros(1,cols(xzall));	                                                    /* boundaries model */
allvars = yxzvars[3:rows(yxzvars)];


			/* ENTER ordered, iop, iopc */

/* 
ordered	        - Ordered probit
iop             - Ordered Probit and Inflated Ordered Probit
giop            - Generalised (moving boundaries) IOP model (and nested sub-models)
iop_REX         - IOP (plus sub-models) with a single RE in the probit equation
iop_REZ         - IOP (plus sub-models) with a single RE in the OP equation
iop_RE          - IOP (plus sub-models) with independent REs in both equations
iop_REfull      - IOP (plus sub-models) with dependent REs in both equations
iopc            - Correlated IOP (plus sub) model 
iopc_RE         - Correlated IOP (plus sub) model, with independent REs in both equations
iopc_REfull     - Correlated IOP (plus sub) model, with dependent REs in both equations
giopc_REfull    - Generalised correlated IOP (plus sub) model, with dependent REs in both equations
*/

let model	= ordered;        
let model	= iop;
let model   = giop;
let model   = iop_REZ;
let model   = iop_REX;
let model   = iop_RE;
let model   = iop_REfull;
let model	= iopc;
let model   = iopc_RE;
let model   = iopc_REfull;
let model   = giopc_REfull;

                                            /* CURRENTLY ESTIMATES FULL MODEL: CHANGE IF REQUIRED! */

/*
let model	= ordered;
let model   = iop;                                            
let model   = iopc;
*/

let model   = iopc;
let model	= ordered;
let model   = iopc_REfull;

let mtype = ordered iop giop iop_REZ iop_REX iop_RE iop_REfull iopc iopc_RE iopc_REfull giopc_REfull; 
mtype = indcv(model,mtype); 


/* ENTER WHICH OUTCOME TO INFLATE ie j = 0,...,?*/

index = 1;      @ this refers to the j=0,...J-1: = 1 for 3 outcomes and 2 for 5 @


/* ENTER 1 TO ESTMATED SIMULATED MARGINAL EFFECTS; 0 OTHERWISE */

sim_ME = 0;      @ note only applies to random effects models; and only applies to model type sepcified above (not sub-models) @


/* ENTER 1 TO SKIP ALL SINGLE RE MODELS; 2 TO SKIP ALL SINGLE AND UNCORRELATED RE MODELS; 0 OTHERWISE */

skip_RE = 2;        @ set to 0 for all sub-models; 1 to skip 1-way RE models; 2 to skip 1-way and 2-way uncorrelated REs @
                    @ set to 3 to skip ALL models except iopc_REfull and giopc_REfull @


/* SET DEFAULT TOLERANCE LEVELS -1 MEANS TAKE CML DEFAULTS: NOTE APPLIES TO ALL MODELS */

tol = -1;      @ set to -1 for CML defaults @


/* PRINT ITERATIONS? 1 = YES, 0 = NO */

print_it = 1;      @ set to -1 for CML defaults @


/* ENTER NUMBER OF RANDOM DRAWS FOR RE VARIANTS: SET = 1 IF NO PANEL MODEL REQUIRED; 2 FOR QUADRATURE */

M = 500;

/* ENTER START VALUES - OPTIONAL, SET TO 0 FOR DEFAULT START VALUES */

let stopb = 0.029
0.0454
-0.0547
-0.065
-0.0811
0.103
0.0378
0.1479
-0.0574
-0.178
-0.0778
-0.0431
-0.0518
0.0399
0.1026
0.1066
0.1195
-0.0326
0.197
-0.1804
-0.1345
-0.3785
-0.266
0.2281
-0.2489
-0.0038
-0.1016
0.0611
-0.042
-0.0899
-0.1559
-0.1085
-0.3174
0.0029
0.0549
1.3117
0.8805
0.187
0.1245
-0.0175
0.2654
0.0618
0.1024
0.0573
-0.1825
-0.2292
-0.0483
0.0397
-0.187
-0.0683
-0.0623
2.7553
;

let stgop = 0;

let stpbt = 0.061
-0.2039
0.0738
0.2488
0.0677
-0.3346
-0.1442
-0.1474
-0.1685
-0.1232
-0.1571
-0.0669
-0.1119
-0.0606
-0.1091
-0.2805
-0.1531
-0.2416
-0.0672
-0.3211
-0.4517
-0.4401
-0.1936
-0.2745
-0.1452
-0.3345
-0.3488
-0.2474
-0.2738
-0.2635
-0.2504
-0.1731
-0.1054
0.0378
-0.0945
2.3109
-0.5204
-0.5394
-0.0481
-0.145
-0.3917
0.1289
-0.0491
-0.037
-0.6265
0.092
0.1803
-1.4745
-0.0736
-1.1087
-0.6408
-0.4944
-0.4075
-0.3765
-0.2846
-0.3478
-0.1853
-0.2347
-0.2642
-0.2844
-0.6791
-0.2846
0.0458
-0.1329
-0.7017
-0.2594
-0.2813
-0.2584
-0.1134
-0.1923
-0.2187
0.0205
-0.2078
-0.2109
-0.1276
-0.0944
0.2804 
;

let stiop   =  -0.0691
0.1309
-0.0224
-0.3455
-0.0683
0.408
0.1533
0.1721
0.2217
0.1608
0.2089
0.0998
0.1332
0.0615
0.116
0.3343
0.1824
0.3068
0.0827
0.3807
0.545
0.4584
0.2319
0.2903
0.1994
0.393
0.4178
0.276
0.3364
0.3228
0.3025
0.2313
0.1315
-0.1194
0.084
-2.3168
0.65
0.6758
0.0536
0.1579
0.3825
-0.1323
0.0549
0.0264
0.7351
-0.079
-0.2017
2.6042
0.0875
1.3087
0.7266
0.5582
0.4674
0.4348
0.3285
0.3992
0.2182
0.272
0.3001
0.326
0.7708
0.323
-0.0366
0.16
0.8351
0.3246
0.3327
0.3056
0.1253
0.2209
0.241
-0.0181
0.2626
0.2517
0.1644
0.1019
-0.3556
0.0514
0.1935
-0.185
-0.1539
-0.113
0.2979
0.2921
0.3107
0.0518
-0.1594
0.0555
0.0701
0.1526
0.2898
0.3631
0.4432
0.616
0.1917
0.6726
-0.0182
0.0788
-0.4844
-0.1663
0.9215
-0.1769
0.2766
0.0768
0.3892
0.1034
0.1301
0.0832
0.1324
-0.2406
0.9642
0.647
-0.08
0.7173
0.2767
0.1165
-0.0056
0.4253
0.1122
0.1628
0.0851
-0.0664
-0.2908
-0.0298
0.0475
-0.2951
-0.1023
-0.07
0.8053
;

let stgiop   = 0
;


let stiopREZ    = 0
;

let stiopREX    = 0
;

let stiopRE     = 0
;

let stiopREfull = -0.0611
0.098
-0.0272
-0.3312
-0.0983
0.459
0.1481
0.1779
0.1755
0.132
0.1992
0.0841
0.1215
0.0588
0.1166
0.34
0.1903
0.3381
-0.0107
0.2975
0.6121
0.5459
0.1022
0.2912
0.1334
0.3966
0.4162
0.256
0.3956
0.2958
0.3063
0.2147
0.1322
-0.1349
0.0398
-2.1825
0.703
0.6041
0.0627
0.1684
0.447
-0.1374
0.0564
0.0186
0.9207
-0.0532
-0.121
3.9516
0.0933
0.7939
0.2686
0.1657
0.1185
0.1055
0.0323
0.1178
-0.0305
0.0407
0.0801
0.1355
0.6403
0.1828
-0.1944
0.0717
0.8809
0.3827
0.3974
0.3581
0.1551
0.2468
0.28
-0.0156
0.2681
0.2687
0.1741
0.1025
-0.3179
0.1235
0.2903
-0.1157
-0.1399
-0.1308
0.3564
0.3616
0.3924
0.2282
-0.0038
0.2555
0.2485
0.3623
0.4552
0.4423
0.6171
0.8478
0.316
0.9668
0.2854
0.2659
-0.5623
0.1358
1.123
-0.0713
0.4489
0.213
0.5629
0.1589
0.3308
0.2711
0.3718
-0.0415
1.2057
0.803
-0.1973
0.7636
0.353
0.1229
-0.0456
0.4169
0.1235
0.1758
0.0858
-0.0402
-0.3363
-0.0347
0.0484
-0.2906
-0.1017
-0.0611
0.9258
0.7193
0.4291
-0.1053
;

let stiopREfull = 
-0.0807
0.147
-0.0481
-0.3468
-0.1175
0.4773
0.2053
0.2238
0.219
0.185
0.2376
0.0838
0.0943
0.0107
0.109
0.3221
0.1517
0.2523
-0.0165
0.3375
0.5937
0.4775
0.1219
0.2402
0.1217
0.4014
0.411
0.2453
0.3493
0.2766
0.2888
0.188
0.0358
-0.1936
0.0197
-2.2932
0.7018
0.5359
0.0676
0.1945
0.4455
-0.1823
0.0638
0.0209
0.9676
-0.077
-0.1195
4.3382
0.0932
0.8529
0.3393
0.2426
0.2033
0.1989
0.123
0.2204
0.0659
0.1386
0.1942
0.2413
0.7658
0.2922
-0.0951
0.1538
0.9286
0.3977
0.4125
0.3893
0.1707
0.259
0.3109
-0.0117
0.2648
0.2807
0.1823
0.1262
-0.2882
0.1287
0.2612
-0.1073
-0.1605
-0.1021
0.3443
0.317
0.3428
0.1296
-0.1699
0.0947
0.1191
0.2497
0.401
0.4655
0.715
0.9737
0.5182
1.0331
0.2998
0.3425
-0.433
0.1601
1.5671
0.0284
0.5839
0.3291
0.7054
0.2474
0.4527
0.3653
0.4586
0.133
1.4154
1.0098
-0.1794
0.8736
0.3471
0.1189
-0.0429
0.402
0.1165
0.1757
0.0909
-0.0859
-0.3289
-0.033
0.0343
-0.2755
-0.0857
-0.0585
1.0032
0.7973
0.4633
-0.1463
;

let stiopc      = -0.0691
0.1312
-0.021
-0.3458
-0.069
0.4091
0.1521
0.1705
0.221
0.1596
0.2087
0.0995
0.1327
0.0603
0.1154
0.3348
0.182
0.3074
0.0819
0.3803
0.5434
0.4582
0.2336
0.2899
0.1996
0.3942
0.4179
0.2774
0.3387
0.3234
0.3023
0.2319
0.1322
-0.1222
0.0837
-2.3131
0.6478
0.6759
0.0546
0.1525
0.3835
-0.1294
0.0551
0.025
0.7388
-0.0754
-0.2124
2.6032
0.0896
1.3098
0.7272
0.5597
0.4678
0.4342
0.3274
0.4014
0.2192
0.275
0.2968
0.3196
0.7654
0.3161
-0.0337
0.1592
0.8354
0.3248
0.3347
0.3063
0.1264
0.2235
0.2392
-0.0188
0.2627
0.2576
0.1675
0.1005
-0.355
0.0479
0.1944
-0.1807
-0.1526
-0.1142
0.3
0.2878
0.3126
0.0482
-0.1628
0.0556
0.0632
0.1488
0.2812
0.3627
0.4573
0.6027
0.1844
0.6631
-0.0159
0.0966
-0.4889
-0.1684
0.915
-0.1814
0.2712
0.0934
0.3881
0.0958
0.1224
0.0799
0.117
-0.244
0.9526
0.6313
-0.1487
0.7306
0.2791
0.1252
-0.0103
0.4408
0.1107
0.1618
0.0837
-0.0719
-0.2945
-0.0331
0.0405
-0.3092
-0.1014
-0.0686
0.8033
0.0604
;

let stiopcRE = 0
;

let stiopcREfull = 
-0.0654
0.1306
-0.0248
-0.346
-0.0782
0.4092
0.148
0.168
0.2069
0.1506
0.214
0.0956
0.1339
0.0587
0.1158
0.3418
0.1811
0.3071
0.0801
0.3725
0.5496
0.4608
0.2257
0.2887
0.1891
0.3931
0.4224
0.2744
0.3391
0.32
0.3008
0.2276
0.133
-0.1224
0.0813
-2.3354
0.671
0.6763
0.0605
0.1602
0.4162
-0.1261
0.0573
0.0121
0.7446
-0.079
-0.2196
2.6036
0.0834
1.1964
0.6724
0.5374
0.4619
0.4337
0.3392
0.4091
0.2302
0.2868
0.3087
0.332
0.7863
0.3276
-0.028
0.2051
0.8479
0.3316
0.3414
0.3067
0.1208
0.2194
0.2339
-0.0229
0.2586
0.2531
0.1612
0.1027
-0.3536
0.0682
0.1958
-0.1767
-0.152
-0.1152
0.2988
0.2884
0.3041
0.0558
-0.1571
0.0742
0.074
0.1618
0.2869
0.3609
0.4626
0.603
0.1852
0.6635
-0.0135
0.1059
-0.4913
-0.1639
0.9152
-0.1808
0.2742
0.0961
0.3902
0.0954
0.1244
0.0828
0.1208
-0.2439
0.9532
0.6311
-0.1116
0.7626
0.3258
0.1335
-0.0018
0.4425
0.1239
0.1771
0.0923
-0.0431
-0.3108
-0.0354
0.0171
-0.3108
-0.1034
-0.0667
0.8613
0.5819
0.3853
-0.0413
0.0746
;


let stiopcREfull = 
-0.062
0.1022
-0.0212
-0.3193
-0.1024
0.4446
0.1361
0.172
0.1725
0.126
0.1956
0.0801
0.1188
0.0465
0.1046
0.3149
0.1856
0.3029
-0.0329
0.3106
0.6131
0.5474
0.1179
0.3012
0.1366
0.3856
0.3949
0.2529
0.4122
0.263
0.3016
0.2405
0.1071
-0.1342
0.0424
-2.1969
0.7093
0.6439
0.0612
0.1658
0.4473
-0.1071
0.0541
0.0182
0.8656
0.0448
-0.0685
5.9809
0.0927
0.7807
0.2519
0.1459
0.1005
0.0897
0.0112
0.0973
-0.054
0.0155
0.0592
0.1197
0.6203
0.1646
-0.2131
0.0304
0.8656
0.3832
0.3942
0.3461
0.1482
0.2378
0.2603
-0.0295
0.2721
0.2606
0.165
0.0846
-0.3373
0.1365
0.2991
-0.1699
-0.0808
-0.1461
0.3668
0.3697
0.3817
0.1971
-0.047
0.1894
0.1904
0.2907
0.3947
0.4016
0.605
0.8296
0.4909
0.9915
0.2383
0.2176
-0.6163
0.0356
1.1145
-0.0639
0.3724
0.1426
0.5491
0.1447
0.3601
0.2762
0.295
-0.0655
1.2334
0.7563
-0.0727
0.7871
0.3482
0.1195
-0.0228
0.3774
0.1269
0.1752
0.0874
-0.0585
-0.3315
-0.0339
0.0339
-0.2552
-0.1047
-0.0628
0.9506
0.7134
0.4308
-0.1164
-0.0632
;

let stiopcREfull = 
-0.0716
0.1314
-0.0197
-0.3459
-0.074
0.4078
0.1522
0.1694
0.2148
0.1577
0.2107
0.0949
0.1292
0.0531
0.1144
0.3368
0.1815
0.3061
0.0811
0.378
0.5456
0.4575
0.2295
0.2896
0.1952
0.3934
0.4182
0.2754
0.3379
0.3211
0.2991
0.2292
0.1313
-0.1227
0.083
-2.3358
0.6569
0.6757
0.0538
0.1591
0.3947
-0.1295
0.0509
0.0139
0.7377
-0.0795
-0.2232
2.6031
0.0755
1.2535
0.7053
0.5515
0.4664
0.4355
0.3308
0.4051
0.2235
0.2793
0.3022
0.3245
0.7738
0.3201
-0.0311
0.1725
0.841
0.3257
0.3358
0.3056
0.1235
0.2199
0.2347
-0.0225
0.2598
0.2551
0.1634
0.103
-0.3536
0.0528
0.195
-0.1781
-0.1525
-0.1115
0.3029
0.291
0.3134
0.0523
-0.162
0.0626
0.0668
0.1524
0.2849
0.3672
0.4601
0.6028
0.1847
0.6631
-0.0133
0.0997
-0.4893
-0.1647
0.9153
-0.1791
0.2742
0.0961
0.3917
0.0948
0.1235
0.0829
0.1182
-0.244
0.9523
0.6317
-0.1153
0.7511
0.3011
0.1278
-0.0056
0.4414
0.1158
0.1673
0.092
-0.0506
-0.2943
-0.0314
0.0015
-0.3107
-0.0948
-0.0625
0.8365
0.5518
0.4055
-0.1528
0.0893
;


let stgiopcREfull = 0
;


    {probit, me_probit, me_probitse, V_probit, loglprobit, 
            AICprobit, BICprobit, CAICprobit, pprobit, retprobit, et_probit,
    ordprb, me_op, me_opse, V_op, loglop, 
            AICop, BICop, CAICop, pordp, retopb, et_op, 
	iop, me_iop, me_iopse, me0_iop, me0_iopse, me_cond_iop, me_cond_iop_se, V_iop, logliop, 
            AICiop, BICiop, CAICiop, piop, p0_iop, retiop, et_iop, 
	giop, me_giop, me_giopse, me0_giop, me0_giopse, meWgiop, meWgiopse, me_cond_giop, me_cond_giop_se, V_giop, loglgiop, 
            AICgiop, BICgiop, CAICgiop, pgiop, p0_giop, retgiop, et_giop, 
	iopREZ, me_iopREZ, me_iopREZse, me0_iopREZ, me0_iopREZse, me_cond_iopREZ, me_cond_iopREZ_se, V_iopREZ, logliopREZ, 
            AICiopREZ, BICiopREZ, CAICiopREZ, piopREZ, p0_iopREZ, retiopREZ, et_iop_REZ,
	iopREX, me_iopREX, me_iopREXse, me0_iopREX, me0_iopREXse, me_cond_iopREX, me_cond_iopREX_se, V_iopREX, logliopREX, 
            AICiopREX, BICiopREX, CAICiopREX, piopREX, p0_iopREX, retiopREX, et_iop_REX,
	iopRE, v_cov_RE, me_iopRE, me_iopREse, me0_iopRE, me0_iopREse, me_cond_iopRE, me_cond_iopRE_se, V_iopRE, logliopRE, 
            AICiopRE, BICiopRE, CAICiopRE, piopRE,  p0_iopRE, retiopRE,  et_iop_RE,  
	iopREfull, v_cov_REfull, me_iopREfull, me_iopREfullse, me0_iopREfull, me0_iopREfullse, me_cond_iopREfull, me_cond_iopREfull_se, V_iopREfull, logliopREfull, 
            AICiopREfull, BICiopREfull, CAICiopREfull, piopREfull,  p0_iopREfull, retiopREfull,  et_iop_REfull,  
	iopc, me_iopc, me_iopcse, me0_iopc, me0_iopcse, me_cond_iopc, me_cond_iopc_se, V_iopc, logliopc, 
            AICiopc, BICiopc, CAICiopc, piopc, p0_iopc, retiopc, et_iopc,
    iopcRE, v_cov_REc, me_iopcRE, me_iopcREse, me0_iopcRE, me0_iopcREse, me_cond_iopcRE, me_cond_iopcRE_se,  V_iopcRE, logliopcRE, 
            AICiopcRE, BICiopcRE, CAICiopcRE, piopcRE, p0_iopcRE, retiopcRE, et_iopcRE, 
    iopcREfull, v_cov_REcfull, me_iopcREfull, me_iopcREfullse, me0_iopcREfull, me0_iopcREfullse, me_cond_iopcREfull, me_cond_iopcREfull_se, V_iopcREfull, logliopcREfull, 
            AICiopcREfull, BICiopcREfull, CAICiopcREfull, piopcREfull, p0_iopcREfull, retiopcREfull, et_iopcREfull,
    giopcREfull, v_cov_gREcfull, me_giopcREfull, me_giopcREfullse, me0_giopcREfull, me0_giopcREfullse, meWgiopcREfull, meWgiopcREfullse, me_cond_giopcREfull, me_cond_giopcREfull_se, V_giopcREfull, loglgiopcREfull, 
            AICgiopcREfull, BICgiopcREfull, CAICgiopcREfull, pgiopcREfull, p0_giopcREfull, retgiopcREfull, et_giopcREfull} 

        = inf_opRE("BoFdatR1",model,stopb,stgop,stpbt,stiop,stgiop,stiopREZ,stiopREX,stiopRE,stiopREfull,stiopc,stiopcRE,stiopcREfull,stgiopcREfull,
                    x_vec,z_vec,w_vec,index,M,sim_ME,skip_RE,tol,print_it);
        

/* PRINT RESULTS */

/* CLEAR SCREEN */

/* cls;  */

xvars       = selif(allvars,x_vec');
zvars       = selif(allvars,z_vec');
wvars       = selif(allvars,w_vec');

let mu	    = mu;
opbvars	    = zvars|(mu .*. ones(capJ-2,1));
iopvars     = xvars|opbvars;


/* VARIABLES FOR ME'S */

commonvec   = x_vec .* z_vec;
x_only      = (1 - z_vec) .* x_vec;
z_only      = (1 - x_vec) .* z_vec;

if sumc(commonvec') ge 1;
    bg_only     = selif(wxzvars,commonvec');
endif;

if sumc(x_only') ge 1;
    b_only  = selif(wxzvars,x_only');
endif;

if sumc(z_only') ge 1;
    g_only  = selif(wxzvars,z_only');
endif;

let se = "s.e.";


                        /* CHANGE DIRECTORY/FILENAME AS APPROPRIATE BELOW */


//let outputfile  = /nfs/monash/home/mnharris/BOF_JAE/BOF_JAE_R1.out reset;
output file = e:\mark\gauss\output\firms\BoF_JoAE_R1.out reset;
//output file = outputfile;
output on;

format 15,4;

?;
"               RANDOM EFFECTS INFLATED ORDERED PROBIT MODELS";
?;
"DATE IS";;datestring(0);
?;
"OUTCOME WHICH HAS BEEN INFLATED";;index;
?;
"Note Model";;$model;
"Simulated ME's?";
if sim_ME eq 1;
    "YES";
else;
    "NO";
endif;

?;
"No. of Random Draws (for RE versions)";;M;?;

"DESCRIPTIVE STATISTICS";?;
{ vnam,mean,var,std,min,max,valid,mis } = dstat("BoFdatR1",yxzvars);
?;


if skip_RE eq 3;
    goto res_iopcREfull;
endif;


print;
print;
"ORDERED PROBIT";
print;
"Convergence code:";;$retopb;
print;
format 10,8;
"Max L";;loglop;
print;
" AIC       BIC         CAIC";
print;
AICop~BICop~CAICop;
print;
save pordp;

format 15,4;

?;
"Sample Proportions and Average Predicted Probabilities";?;
(phat')|(meanc(pordp)');?;

print;
"Time in hours for convergence";;et_op;
print;

print;
"ESTIMATED PARAMETERS";
print;

for i (1,rows(ordprb),1);
	$opbvars[i];;ordprb[i,.];
endfor;
print;

"MARGINAL EFFECTS AND STANDARD ERRORS";
print;
for i (1,sumc(z_vec'),1);
	$zvars[i];;me_op[i,.];
    $se;;me_opse[i,.];
endfor;
print;


if mtype ge 2;

    print;
    print;
    "SIMPLE PROBIT MODEL FOR INDEX EQUATION";
    print;
    "Convergence code:";;$retprobit;
    print;
    format 10,8;
    "Max L";;loglprobit;
    print;
    " AIC       BIC         CAIC";
    print;
    AICprobit~BICprobit~CAICprobit;  
    print;
    save pprobit;
    format 15,4;

    print;
    "Time in hours for convergence";;et_probit;
    print;

    "ESTIMATED SPLITTING FUNCTION PARAMETERS";
    print;
    for i (1,rows(xvars),1);
	    $xvars[i];;probit[i,.];
    endfor;
    print;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    for i (1,rows(xvars),1);
	    $xvars[i];;me_probit[i,.];
        $se;;me_probitse[i,.];
    endfor;
    print;

endif;


if mtype ge 2;

    print;
    print;
    "INFLATED ORDERED PROBIT";
    print;
    "Convergence code:";;$retiop;
    print;
    format 10,8;
    "Max L";;logliop;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiop~BICiop~CAICiop;  
    print;
    save piop;
    format 15,4;
    save piop;
    "Time in hours for convergence";;et_iop;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piop)');?;


    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Posterior 1st Stage; Posterior 2nd Stage";
    ?;
    p0_iop;
    ?;

    print;
    "Estimated  Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iop[i,.];
    endfor;
    print;

    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iop),1);
	    $iopvars[i];;iop[i,.];
    endfor;
    print; 

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
	
	if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iop[sumc(commonvec')+i,.];
            $se;;me_iopse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iop[sumc(commonvec')+sumc(x_only')+i,.];
            $se;;me_iopse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iop[i,.];
            $se;;me_iopse[i,.];
        endfor;
        print;
    endif;


    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iop[i,.];
            $se;;me0_iopse[i,.];
        endfor;
        print;
    endif;

    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iop[sumc(commonvec')+i,.];
            $se;;me0_iopse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

    
    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS CONDITIONAL ON PRICE REVIEW";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_cond_iop[i,.];
            $se;;me_cond_iop_se[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_cond_iop[sumc(commonvec')+i,.];
            $se;;me_cond_iop_se[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_cond_iop[sumc(commonvec')+sumc(x_only')+i,.];
            $se;;me_cond_iop_se[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

   

endif;


//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype eq 4 or mtype eq 6 or mtype eq 7 or mtype ge 9 and skip_RE eq 0;

    print;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: EFFECTS ONLY IN ORDERED EQUATION";
    print;
    "Convergence code:";;$retiopREZ;
    print;
    format 10,8;
    "Max L";;logliopREZ;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopREZ~BICiopREZ~CAICiopREZ;  
    print;
    save piopREZ;
    format 15,4;
    "Time in hours for convergence";;et_iop_REZ;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopREZ)');?;


    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopREZ;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopREZ[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopREZ)-1,1);
	    $iopvars[i];;iopREZ[i,.];
    endfor;
    print; 
    "Estimated Panel Correlation Over Time";
    print;
    "panel_r";;abs(iopREZ[rows(iopREZ),.]);
    print;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopREZ[i,.];
            let se = "s.e.";$se;;me_iopREZse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopREZ[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopREZse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopREZ[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopREZse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopREZ[i,.];
            let se = "s.e.";$se;;me0_iopREZse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopREZ[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopREZse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

endif;

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype eq 5 or mtype eq 6 or mtype eq 7 or mtype ge 9 and skip_RE eq 0;

    print;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: EFFECTS ONLY IN SELECTION EQUATION";
    print;
    "Convergence code:";;$retiopREX;
    print;
    format 10,8;
    "Max L";;logliopREX;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopREX~BICiopREX~CAICiopREX;  
    print;
    print;
    save piopREX;
    format 15,4;
    "Time in hours for convergence";;et_iop_REX;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopREX)');?;

    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopREX;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopREX[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopREX)-1,1);
	    $iopvars[i];;iopREX[i,.];
    endfor;
    print; 
    "Estimated Panel Correlation Over Time";
    print;
    "Panel_r";;abs(iopREX[rows(iopREX),.]);
    print;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopREX[i,.];
            let se = "s.e.";$se;;me_iopREXse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopREX[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopREXse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopREX[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopREXse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopREX[i,.];
            let se = "s.e.";$se;;me0_iopREXse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopREX[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopREXse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

endif;

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype eq 6 or mtype eq 7 or mtype ge 9 and skip_RE le 1;

    print;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: EFFECTS IN BOTH EQUATIONS";
    print;
    "Convergence code:";;$retiopRE;
    print;
    format 10,8;
    "Max L";;logliopRE;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopRE~BICiopRE~CAICiopRE;  
    print;
    print;
    save piopRE;
    format 15,4;
    "Time in hours for convergence";;et_iop_RE;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopRE)');?;


    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopRE;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopRE[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopRE)-2,1);
	    $iopvars[i];;iopRE[i,.];
    endfor;
    print; 
    "Estimated Standard Deviation Termss with Standard Errors and t-stats";
    print;
    "OP equation";;iopRE[rows(iopRE)-1,.];
    "probit equation";;iopRE[rows(iopRE),.];
    print;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopRE[i,.];
            let se = "s.e.";$se;;me_iopREse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopRE[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopREse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopRE[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopREse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopRE[i,.];
            let se = "s.e.";$se;;me0_iopREse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopRE[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopREse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

endif;

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype eq 7 or mtype ge 10;

    print;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: CORRELATED EFFECTS IN BOTH EQUATIONS";
    print;
    "Convergence code:";;$retiopREfull;
    print;
    format 10,8;
    "Max L";;logliopREfull;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopREfull~BICiopREfull~CAICiopREfull;  
    print;
    print;
    save piopREfull;
    format 15,4;
    "Time in hours for convergence";;et_iop_REfull;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopREfull)');?;

    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopREfull;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopREfull[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopREfull)-3,1);
	    $iopvars[i];;iopREfull[i,.];
    endfor;
    print; 
    "Estimated Covariance Terms with Standard Errors and t-stats";
    print;
    "OP equation";;v_cov_REfull[1,.];
    "probit equation";;v_cov_REfull[2,.];
    "covariance";;v_cov_REfull[3,.];
    print;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopREfull[i,.];
            let se = "s.e.";$se;;me_iopREfullse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopREfull[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopREfullse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopREfull[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopREfullse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopREfull[i,.];
            let se = "s.e.";$se;;me0_iopREfullse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopREfull[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopREfullse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS CONDITIONAL ON PRICE REVIEW";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_cond_iopREfull[i,.];
            $se;;me_cond_iopREfull_se[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_cond_iopREfull[sumc(commonvec')+i,.];
            $se;;me_cond_iopREfull_se[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_cond_iopREfull[sumc(commonvec')+sumc(x_only')+i,.];
            $se;;me_cond_iopREfull_se[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;


endif;

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype ge 8;

    print;
    print;
    "CORRELATED INFLATED ORDERED PROBIT";
    print;
    "Convergence code:";;$retiopc;
    print;
    format 10,8;
    "Max L";;logliopc;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopc~BICiopc~CAICiopc;  
    print;
    save piopc;
    format 15,4;
    "Time in hours for convergence";;et_iopc;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopc)');?;

    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Posterior 1st Stage; Posterior 2nd Stage";
    ?;
    p0_iopc;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopc[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopc)-1,1);
	    $iopvars[i];;iopc[i,.];
    endfor;
    print; 
    "Correlation Between the Two Equation's Idiosynctractic Error Terms";
    print;
    "Rho";;iopc[rows(iopc),.];
    print;   

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopc[i,.];
            let se = "s.e.";$se;;me_iopcse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopc[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopcse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopc[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopcse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopc[i,.];
            let se = "s.e.";$se;;me0_iopcse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopc[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopcse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;


    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS CONDITIONAL ON PRICE REVIEW";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_cond_iopc[i,.];
            $se;;me_cond_iopc_se[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_cond_iopc[sumc(commonvec')+i,.];
            $se;;me_cond_iopc_se[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_cond_iopc[sumc(commonvec')+sumc(x_only')+i,.];
            $se;;me_cond_iopc_se[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;


endif;

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype ge 9 and skip_RE le 1;

    print;
    print;
    "FULL RANDOM EFFECTS CORRELATED INFLATED ORDERED PROBIT";
    print;
    "Convergence code:";;$retiopcRE;
    print;
    format 10,8;
    "Max L";;logliopcRE;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopcRE~BICiopcRE~CAICiopcRE;  
    print;
    save piopcRE;
    format 15,4;
    "Time in hours for convergence";;et_iopcRE;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopcRE)');?;


    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopcRE;
    ?;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopcRE[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopcRE)-3,1);
	    $iopvars[i];;iopcRE[i,.];
    endfor;
    print; 
    "Estimated Standard Deviation Terms with Standard Errors and t-stats";
    print;
    "OP equation";;iopcRE[rows(iopcRE)-2,.];
    "probit equation";;iopcRE[rows(iopcRE)-1,.];
    print;
    print;
    "Correlation Between the Two Equation's Idiosynctractic Error Terms";
    print;
    "Rho";;iopcRE[rows(iopcRE),.];
    print;   

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopcRE[i,.];
            let se = "s.e.";$se;;me_iopcREse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopcRE[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopcREse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopcRE[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopcREse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopcRE[i,.];
            let se = "s.e.";$se;;me0_iopcREse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopcRE[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopcREse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

endif;

res_iopcREfull:

//let mtype = 1.ordered 2.iop 3.giop 4.iop_REZ 5.iop_REX 6.iop_RE 7.iop_REfull 8.iopc 9.iopc_RE 10.iopc_REfull 11.giopc_REfull; 
if mtype ge 10;

    print;
    print;
    "FULL CORRELATED RANDOM EFFECTS CORRELATED INFLATED ORDERED PROBIT";
    print;
    "Convergence code:";;$retiopcREfull;
    print;
    format 10,8;
    "Max L";;logliopcREfull;
    print;
    " AIC       BIC         CAIC";
    print;
    AICiopcREfull~BICiopcREfull~CAICiopcREfull;  
    print;
    save piopcREfull;
    format 15,4;
    "Time in hours for convergence";;et_iopcREfull;
    print;

    ?;
    "Sample Proportions and Average Predicted Probabilities";?;
    (phat')|(meanc(piopcREfull)');?;

    "           ****Split of Probabilities for Augmented Outcome****";?;
    "   Av Total Prob; Of which from 1st stage; Total % Predicted; % of Total from 1st Stage";
    ?;
    p0_iopcREfull;

    print;
    "Estimated Splitting Function Parameters";
    print;
    for i (1,rows(xvars),1);
	    $iopvars[i];;iopcREfull[i,.];
    endfor;
    print;
    "Estimated Ordered Parameters";;
    print;
    for i (rows(xvars)+1,rows(iopcREfull)-4,1);
	    $iopvars[i];;iopcREfull[i,.];
    endfor;
    print; 
    "Estimated Covariance Terms with Standard Errors and t-stats";
    print;
    "OP equation";;v_cov_REcfull[1,.];
    "probit equation";;v_cov_REcfull[2,.];
    "covariance";;v_cov_REcfull[3,.];
    print;
    print;
    "Correlation Between the Two Equation's Idiosynctractic Error Terms";
    print;
    "Rho";;iopcREfull[rows(iopcREfull),.];
    print;   

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_iopcREfull[i,.];
            let se = "s.e.";$se;;me_iopcREfullse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_iopcREfull[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me_iopcREfullse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_iopcREfull[sumc(commonvec')+sumc(x_only')+i,.];
            let se = "s.e.";$se;;me_iopcREfullse[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;

    "DECOMPOSE TOTAL MARGINAL EFFECTS OF AUGMENTED OUTCOME";
    print;
    if sumc(commonvec') ge 1;
        "VARIABLES IN BOTH X AND Z";
        print;
        "       *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me0_iopcREfull[i,.];
            let se = "s.e.";$se;;me0_iopcREfullse[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        print;
        "           *NON-PARTICIPATION*    *PARTICIPATION*";
        print; 
        for i (1,sumc(x_only'),1);
            $b_only[i];;me0_iopcREfull[sumc(commonvec')+i,.];
            let se = "s.e.";$se;;me0_iopcREfullse[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;

    "OVERALL MARGINAL EFFECTS AND STANDARD ERRORS CONDITIONAL ON PRICE REVIEW";
    print;
    if sumc(commonvec') ge 1;
        print;
        "VARIABLES IN BOTH X AND Z";
        for i (1,sumc(commonvec'),1);
            $bg_only[i];;me_cond_iopcREfull[i,.];
            $se;;me_cond_iopcREfull_se[i,.];
        endfor;
        print;
    endif;
    if sumc(x_only') ge 1;
        print;
        "VARIABLES IN ONLY X";
        for i (1,sumc(x_only'),1);
            $b_only[i];;me_cond_iopcREfull[sumc(commonvec')+i,.];
            $se;;me_cond_iopcREfull_se[sumc(commonvec')+i,.];
        endfor;
        print;
    endif;
    if sumc(z_only') ge 1;
        print;
        "VARIABLES IN ONLY Z";
        for i (1,sumc(z_only'),1);
            $g_only[i];;me_cond_iopcREfull[sumc(commonvec')+sumc(x_only')+i,.];
            $se;;me_cond_iopcREfull_se[sumc(commonvec')+sumc(x_only')+i,.];
        endfor;
        print;
    endif;
    print;


endif;

hitmiss:


/* PRINT OUT HIT AND MISS TABLE */

"               HIT AND MISS TABLES";

if skip_RE eq 3;
    goto skip_HM;
endif;

print;
print;
"ORDERED PROBIT";
{ table1} = hitmiss(pordp,y);
print;


if mtype ge 2;
	print;
	"INFLATED ORDERED PROBIT";
	{ table2} = hitmiss(piop,y);
	print;
endif;


if mtype eq 4 or mtype eq 5 or mtype eq 6 or mtype eq 8;
	print;
	"RANDOM EFFECTS INFLATED ORDERED PROBIT: RANDOM EFFECTS ONLY IN ORDERED EQUATION";
	{ table3} = hitmiss(piopREZ,y);
	print;
endif;


if mtype eq 4 or mtype eq 5 or mtype eq 6 or mtype eq 8;
	print;
	"RANDOM EFFECTS INFLATED ORDERED PROBIT: RANDOM EFFECTS ONLY IN SELECTION EQUATION";
	{ table4} = hitmiss(piopREX,y);
	print;
endif;


if mtype eq 5 or mtype eq 6 or mtype eq 8;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: EFFECTS ONLY IN BOTH EQUATIONS";
	{ table5} = hitmiss(piopRE,y);
	print;
endif;


if mtype eq 6 or mtype eq 8;
    print;
    "RANDOM EFFECTS INFLATED ORDERED PROBIT: CORRELATED EFFECTS IN BOTH EQUATIONS";
	{ table6} = hitmiss(piopREfull,y);
	print;
endif;


if mtype ge 7;
	print;
    "CORRELATED INFLATED ORDERED PROBIT";
	{ table7} = hitmiss(piopc,y);
	print;
endif;


if mtype eq 9;
	print;
	"FULL RANDOM EFFECTS CORRELATED INFLATED ORDERED PROBIT";
	{ table8} = hitmiss(piopcRE,y);
	print;
endif;

skip_HM:

if mtype eq 9;
	print;
	"FULL CORRELATED RANDOM EFFECTS CORRELATED INFLATED ORDERED PROBIT";
	{ table9} = hitmiss(piopcREfull,y);
	print;
endif;


output off;
closeall;

stop;

