new;
cls;
library cmlmt;
#include cmlmt.sdf;
closeall;

starttime=timeutc;
user ="HERVE"; 

if user .=="HERVE"; 
output file = V:\00HLBS\00HLBS_Replication_simulation\results\results_baseline.out reset;
elseif user .=="MARK"; 
output file = e:\mark\gauss\output\firms\XXX.out reset;
endif;

output on;

clear index;
clearg cond_Y_N, M, count;

          /* PROGRAM TO IOP and TOP MODELS (for 3 outcomes) */
if user .=="HERVE"; 
#include V:\00HLBS\00HLBS_Replication_simulation\IOP_TOP_RE_MT.prc;
/*
    elseif user .=="MARK";
#include e:\mark\gauss\procs\IOP_TOP_RE_MT.prc; 
    **/
endif;

NREP=1000;

/* SET OF PARAMETERS**/
vec_psi={ 0.5,1.5, 3.0};
vec_psi=vec_psi/100;

vec_theta={ 0.5,3.0};

vec_theta=vec_theta/100;


// PRE ALLOCATING MATRICES THAT STORE RESULTS
number_cases=rows(vec_theta)*rows(vec_psi);

RESULT_BIG_SIGNIF_IOP=zeros(9,number_cases);   //BE CAREFUL here  9 is number of parmeters you estimate
RESULT_PROBA_REVIEW=zeros(3,number_cases); 
RESULT_CASE=zeros(1,number_cases);
RESULT_THETA=zeros(1,number_cases);
RESULT_PSI=zeros(1,number_cases);



compteur=0;

for ii (1,rows(vec_psi),1); ///Loop over "cases" ie parameter sets
    for jj (1,rows(vec_theta),1);

compteur=compteur+1;
v_prob_price_reviews={};   //initializing vector that will save proba of price review for each case


/* GENERATE THE DATA FOLLOWING ALP */
rndseed 17891789;

BIG_SIGNIF_IOP=0;

for my_rep (1,NREP,1); // Loop over MC replications

"my_rep";;my_rep;
if my_rep==383;rndseed 19171789;endif;


//define parameters

//theta   -- observation cost 

theta    = vec_theta[jj];

// phsi -- Menu cost
phsi    = vec_psi[ii];

mu      = 0.0; //inflation rate
alpha   = phsi/theta;
B       = 20;
sig     = 0.15;
sig2    = sig^2;


if my_rep/50==floor(my_rep/50);  
    print;
"************************************************************************************************************";
"CASE  " ;; compteur;
"************************************************************************************************************";
"SUMMARY OF DGP";
"theta (%)  ";;100*theta;
"psi   (%)  ";;100*phsi;
"************************************************************************************************************";
endif;

struct DS d;
d = reshape(dsCreate,2,1);
d[1].DataMatrix = alpha;

struct eqSolvemtControl c;
c = eqSolvemtControlCreate();
 
//Turn on printing of iteration information
c.printIters = 0;
 
//Assign variable names printed output
c.altNames = "psi_alpha";

//Declare 'par' to be an instance of a PV vector
struct PV par;

//Create default PV struct and add a parameter
//named 'x1' with a starting value of 1
par = pvPack(pvCreate(),0, "psi_alpha");
 
//Solve the system of equations
//and print the output to the screen
//Declare output structure to hold results
struct eqSolvemtOut out;


screen off;
//Solve the system of equations
out = eqSolvemt(&fct,par,d,c);
screen on;

//Return the value of 'x1'
psi_alpha = pvUnpack(out.par, "psi_alpha");

//"alpha phi_alpha Solution of the model";;alpha~psi_alpha;


//The definition of the function to be minimized
proc fct(struct PV p, struct DS d);
   local psi_alpha, alpha, a, b, c, z;
    
    psi_alpha   = pvUnpack(p, "psi_alpha");
    alpha	    = d[1].dataMatrix;
    
    a   = (psi_alpha^2);
    b   = 2/alpha;
    c   = 4*(1-cdfn(psi_alpha));
    z   = 1 - (a*(b+c));
    
   retp(z);
endp;


tau_a   = sqrt(theta/(sig2*B));
tau_b   = sqrt(alpha)/psi_alpha;
tau     = tau_a*tau_b;

p_bar_a = (sig2*(phsi/B))^0.25;
p_bar_b = sqrt(psi_alpha);
p_bar   = p_bar_a*p_bar_b;

p_tild0 = 0;
t_vec   = seqa(1,120,1);

tau_a   = sqrt(theta/(sig2*B));
tau_b   = sqrt(alpha)/psi_alpha;
tau     = tau_a*tau_b;

p_bar_a = (sig2*(phsi/B))^0.25;
p_bar_b = sqrt(psi_alpha);
p_bar   = p_bar_a*p_bar_b;

//replicate the ALP grph n figure III
p_vec   = seqa(-0.07,0.0014,100);
T_pstar_vec= ( tau - (p_vec ./ sig).^2 ).*(  abs(p_vec) .le p_bar ) +  tau.*(  abs(p_vec) .gt p_bar )  ;
/**graph 
plotxy(p_vec,T_pstar_vec);
*/
 


/*******                      NOW SIMULATING THE PROCESS AT MONTHLY FREQUENCY                                    ******/


T_max=1000;
trend=seqa(1,1,T_max);
p_vec={};

//Number of periods per year: Set =12 monthly

nperiods=12;
/**Convert tau (Max time to reviews) in months**/
tau_months         = trunc(tau*nperiods)+1;
/**  Normalize  std deviation of shocks **/
sig_months         = sig/sqrt(nperiods);

p_bar_months         = p_bar;


/**Initializing vectors **/
p_change=0;
time_since_review=0;
tau_adjusted=tau_months-(0/sig_months)^2;

ptilde_vec=zeros(T_max,1);
eps=rndn(T_max,1);  //vector of shocks
price=zeros(T_max,1);
time_since_review=zeros(T_max,1);
price_review_vec=zeros(T_max,1);
time_since_change=zeros(T_max,1);
ptilde_at_last_review=zeros(T_max,1);



/****              Loop over tt    **/
tt = 2;
do while tt le T_max;

  //law of motion for p_tilde  
    ptilde= ptilde_vec[tt-1]+sig_months*eps[tt];
    
    /**increment time since last review**/
        time_since_review[tt]=time_since_review[tt-1]+1;
        time_since_change[tt]=time_since_change[tt-1]+1;

   
    if time_since_review[tt] .ge tau_adjusted; // trigger price review 
     price_review=1;
        time_since_review[tt]=0;
        ptilde_at_last_review[tt]=ptilde;
    elseif time_since_review[tt] .lt tau_adjusted;    
    price_review=0;
    ptilde_at_last_review[tt]=ptilde_at_last_review[tt-1];
    endif;     
    
   // CASE 1: price change          
    if (price_review==1) .and (abs(ptilde) .gt abs(p_bar_months)); 
    time_since_change[tt]=0;


if ptilde .gt 0;
        p_Change            = p_Change|-1;
elseif ptilde .lt 0;
        p_Change            = p_Change|1;
endif;    
      
        
        ptilde_vec[tt]=0;                    //reset ptilde for next period
        price[tt]=price[tt-1]-ptilde;
        ptilde_at_last_review[tt]=0;          

 //CASE 2 : no price  change  because either no review,  or  ptilde is within inaction range
     elseif (price_review .ne 1) or (abs(ptilde) .le abs(p_bar_months)) ;    
        
        p_Change    = p_Change|0;
        ptilde_vec[tt]=ptilde; 
        price[tt]=price[tt-1];
      
    endif;

if price_review ==1;
     tau_adjusted=tau_months-(ptilde/sig_months)^2;
endif;
    
 
price_review_vec[tt] = price_review;
    
/**increment time **/
    tt = tt + 1;
    
endo;


//plotxy(trend[1:200],ptilde_vec[1:200]~ptilde_at_last_review[1:200]);


screen off;
"************************************************************************************************************";
"Statistic from simulated data from DGP"; 


dp=price[2:T_max]-price[1:T_max-1];
dp=selif(dp, dp .ne 0);
dp=packr(dp);
"Average frequency of review   ";;s1=meanc( price_review_vec);s1;
"Average time between reviews  ";;s2=1/meanc( price_review_vec);s2;
"Average frequency of change   ";;s3=meanc( price .ne lag(price));s3;  //"check it " ;;meanc( abs(p_change));
"Average absolute change       ";;s4=meanc( abs(dp));s4;
"Standard dev. of price change ";;s5=stdc( dp);s5;


dograph=0;
if dograph == 1;
plotxy(trend,ptilde_vec);
plotxy(trend,price);
plotxy(trend[1:50],time_since_review[1:50]);
plothist(dp,40);
plotxy(trend[1:200],time_since_change[1:200]~time_since_review[1:200]);
 endif;

"************************************************************************************************************";

/***************************/
/** EStimation part*/

//Define observed explanatory variables. 
 
ptilde_obs=lag(ptilde_vec) + 0*rndn(T_max,1)/1;
ptilde_at_last_review=lag(ptilde_at_last_review) ;
tt_s_rev=lag(time_since_review);
tt_s_chg=lag(time_since_change);

//Categorical function for price change -1/0/1
y       = p_change;
y       = y - minc(y);                                      
capJ    = maxc(y) - minc(y) + 1;

idvec   = trend;
date_id	= trend;


/* DEFINE VARIABLES APPEARING  IN ALL EQUATIONS */
x_joint             = tt_s_rev;
let x_joint_vars    = tt_s_rev;

/* DEFINE VARIABLES APPEARING IN  THE REVIEW EQN ONLY(X_UP_ONLY AND X_DOWN_ONLY; NOTE X_UP_ONLY = X_DOWN_ONLY */

x_up_only = ones(T_max,1)~(abs(ptilde_at_last_review) .* 100);
let x_up_only_vars   =  const a_ptirev;

/* DEFINE Z-ONLY VARIABLES APPEARING  ONLY IN PRICE CHANGE */
x_y_only   			= (ptilde_at_last_review .* 100)~(tt_s_chg ./ 12)~(ptilde_obs .* 100);		  
let x_y_only_vars   = pti_last tt_s_chg pti_cur;	

k_y	= cols(x_y_only);


/* DELETE ANY MISSING VALUES */

x_all   = x_joint~x_y_only~x_up_only;        @ STACK DATA IN ORDER: COMMON, X_Y_ONLY, X_UP_ONLY @

yx_all  = packr(y~idvec~x_all);
y 	    = yx_all[.,1];
idvec   = yx_all[.,2];
x_all   = yx_all[.,3:cols(yx_all)];

/* THE CONTIGID ID VECTOR MUST BE CONTIGUOUS! AND START AT 1 */

tvec     = 1;
idcontig = 1;
irep = 2;
do while irep le rows(y);
 
	if idvec[irep] eq idvec[irep-1];

	    idcontig = idcontig|idcontig[irep-1];
	    tvec     = tvec|tvec[irep-1]+1;

	else;

	    idcontig = idcontig|(idcontig[irep-1]+1);
        tvec     = tvec|1;

	endif;

    irep = irep + 1;

endo;

idvec = idcontig;

T 		= maxc(tvec);
capJ	= maxc(y) - minc(y) + 1;
kall    = cols(x_all);
N_all   = rows(y);
N 	    = maxc(idcontig);

/* CREATE A COUNT N BY 1 COUNT VARIABLE */

count = counts(idvec,seqa(1,1,maxc(idvec)));
let count_name = count;

if minc(count) eq 0;
	"Error empty id value";stop;
endif;


			/* NAME X'S & Y'S & SAVE */

let yvars       = expect;
x_all_vars      = x_joint_vars|x_y_only_vars|x_up_only_vars;
let id          = id;
y_x_all_vars    = yvars|id|x_all_vars;

data            = y~idcontig~x_all;

            if not saved(data,"theory_dat",y_x_all_vars);
                errorlog "Disk full";stop;
                end;
            endif;

    /* DESCRIPTIVE STATS 
{ vnam,mean,var,std,min,max,valid,mis } = dstat("theory_dat",y_x_all_vars);      
            */
            
    /* CONSTRUCT INDICATOR VARIABLES FOR j=J */

d_ij	= {};

for jrep (minc(y),maxc(y),1);
	d_ij = d_ij~(y .eq jrep);
endfor;

NT = rows(d_ij);
phat = meanc(d_ij);

/* NEED AN INDICATOR VARIABLE TO LET PROC KNOW WHAT X'S ARE FOR PROBIT MODEL & WHAT Z'S ARE FOR ORDERED MODEL */

/* specifies x's corresponding to "y_x_all_vars" above - ignoring y and same for z's in ordered model */

x_y_vec              	= zeros(1,cols(x_all));                                 /* ordered probit model */
x_y_vec[1:cols(x_joint)]    = ones(1,cols(x_joint));
x_y_vec[cols(x_joint)+1:cols(x_joint)+cols(x_y_only)]    = ones(1,cols(x_y_only));

x_up_vec					= zeros(1,cols(x_all));                            	/* probit model for "ups" */
x_up_vec[1:cols(x_joint)]    = ones(1,cols(x_joint));
x_up_vec[cols(x_joint)+cols(x_y_only)+1:cols(x_joint)+cols(x_y_only)+cols(x_up_only)] = ones(1,cols(x_up_only));

x_down_vec = x_up_vec;															/* probit model for "ups" */

allvars = y_x_all_vars[4:rows(y_x_all_vars)];

x_up	= selif(x_all',x_up_vec')'; 
x_down  = selif(x_all',x_down_vec')'; 
x_y     = selif(x_all',x_y_vec')'; 

k_y  		= cols(x_y);
k_up_down	= cols(x_down);

			/* ENTER ordered, iop, iopc */

/* 
ordered	        - Ordered probit
IOP             - inflated OP
IOPC            - correlated inflated OP
TOP             - tempered OP
TOPC            - corelated tempered OP
note: set M > 1 to request panel versions in addition 
*/
                                            /* CURRENTLY ESTIMATES FULL MODEL: CHANGE IF REQUIRED! */
let model   = IOP;

/* ENTER NUMBER OF RANDOM DRAWS FOR RE VARIANTS: SET = 1 IF NO PANEL MODEL REQUIRED; OR M>1 FOR NUMBER OF HALTON DRAWS */
M = 1;

/* SET DEFAULT TOLERANCE LEVELS -1 MEANS TAKE CML DEFAULTS: NOTE APPLIES TO ALL MODELS */
tol = -1;      @ set to -1 for CML defaults @

/* PRINT ITERATIONS? */

print_it = 0;

/* ENTER INDEX NUMBER FOR INFLATION EG INDEX=2 INFLATES THE MIDDLE CATEGORY FOR J=3 OUTCOMES */
index = 2;

/* ENTER START VALUES - OPTIONAL, SET TO 0 FOR DEFAULT START VALUES */

let start_OP    = 0;
let start_IOP   = 0;
let start_IOP_RE = 0;
let start_IOPC = 0;
let start_IOPC_RE = 0;
let start_TOP   = 0;
let start_TOP_RE   = 0;
let start_TOPC   = 0;
let start_TOPC_RE = 0;


	{OP, V_OP, logl_OP, AIC_OP, BIC_OP, CAIC_OP, p_OP, ret_OP,                                      
        me_OP, me_OP_se,                                                                            
    IOP, V_IOP, logl_IOP, AIC_IOP, BIC_IOP, CAIC_IOP, p_IOP, p_IOP_inf, p_IOP_purged, IOP_inf,      
        ret_IOP, me_IOP, me_IOP_se, me_IOP_inf, me_IOP_p_inf,                                                            
        LM_test,    
    IOP_RE, V_IOP_RE, logl_IOP_RE, AIC_IOP_RE, BIC_IOP_RE, CAIC_IOP_RE, p_IOP_RE, p_IOP_RE_inf, p_IOP_RE_purged, IOP_RE_inf, 
        ret_IOP_RE, me_IOP_RE, me_IOP_RE_se, me_IOP_RE_inf, me_IOP_RE_p_inf,
        LR_IOP_RE,
    IOPC, V_IOPC, logl_IOPC, AIC_IOPC, BIC_IOPC, CAIC_IOPC, p_IOPC, p_IOPC_inf, p_IOPC_purged, IOPC_inf, 
        ret_IOPC, me_IOPC, me_IOPC_se, me_IOPC_inf, me_IOPC_p_inf, 
    IOPC_RE, V_IOPC_RE, logl_IOPC_RE, AIC_IOPC_RE, BIC_IOPC_RE, CAIC_IOPC_RE, p_IOPC_RE, p_IOPC_RE_inf, p_IOPC_RE_purged, IOPC_RE_inf, 
        ret_IOPC_RE, me_IOPC_RE, me_IOPC_RE_se, me_IOPC_RE_inf, me_IOPC_RE_p_inf,
        LR_IOPC_RE,
    TOP, V_TOP, logl_TOP, AIC_TOP, BIC_TOP, CAIC_TOP, p_TOP, p_TOP_up, p_TOP_down, p_TOP_purged, TOP_inf,   
        ret_TOP, me_TOP, me_TOP_se, me_TOP_inf, me_TOP_p_inf, me_TOP_p_inf_se,
        LM_TOPC_vs_TOP, LR_test,
    TOP_RE, V_TOP_RE, logl_TOP_RE, AIC_TOP_RE, BIC_TOP_RE, CAIC_TOP_RE, p_TOP_RE, p_TOP_RE_up, p_TOP_RE_down, p_TOP_RE_purged, TOP_RE_inf, 
        ret_TOP_RE, me_TOP_RE, me_TOP_RE_se, me_TOP_RE_inf, me_TOP_RE_p_inf, me_TOP_RE_p_inf_se,
        LR_TOP_RE,
    TOPC, V_TOPC, logl_TOPC, AIC_TOPC, BIC_TOPC, CAIC_TOPC, p_TOPC, p_TOPC_up, p_TOPC_down, p_TOPC_purged, TOPC_inf,   
        ret_TOPC, me_TOPC, me_TOPC_se, me_TOPC_inf, me_TOPC_p_inf, me_TOPC_p_inf_se,
        LR_corr_vs_non, LM_corr_vs_corr, LM_corr_vs_IOP, LR_corr_vs_corr, LR_corr_vs_IOP, 
    TOPC_RE, V_TOPC_RE, logl_TOPC_RE, AIC_TOPC_RE, BIC_TOPC_RE, CAIC_TOPC_RE, p_TOPC_RE, p_TOPC_RE_up, p_TOPC_RE_down, p_TOPC_RE_purged, TOPC_RE_inf, 
        ret_TOPC_RE, me_TOPC_RE, me_TOPC_RE_se, me_TOPC_RE_inf, me_TOPC_RE_p_inf, me_TOPC_RE_p_inf_se,
        LR_TOPC_RE, LR_corr_vs_non_RE,
    y_star_OP, y_star_IOP, y_star_IOP_RE, y_star_IOPC, y_star_IOPC_RE, y_star_TOP, y_star_TOP_RE, y_star_TOPC, y_star_TOPC_RE}
        
		= IOP_TOP("theory_dat",model,start_OP,start_IOP,start_IOP_RE,start_IOPC,start_IOPC_RE,start_TOP,start_TOP_RE,start_TOPC,start_TOPC_RE,
                        x_up_vec,x_down_vec,x_y_vec,tol,print_it,tvec);


/* PRINT RESULTS */

/* CLEAR SCREEN */

/* cls;  */

x_y_vars		= selif(x_all_vars,x_y_vec');
x_up_vars      	= selif(x_all_vars,x_up_vec');
x_down_vars    	= selif(x_all_vars,x_down_vec');

let mu	    = mu;
OP_vars	    = x_y_vars|(mu .*. ones(capJ-1,1));
//miopvars    = opbvars|x_up_only_vars||x_down_only_vars;
let se = "s.e.";

let mtype = ordered IOP IOPC TOP TOPC;
mtype = indcv(model,mtype); 

screen on;

/*"**************************************************************************************";*/
"MODEL ABILITY TO DISCRIMINATE BETWEEN ACTUAL REVIEWS AND NON REVIEWS";
load p_inf_IOP;
//sortc(p_inf_IOP~price_review_vec[2:T_max],2);
"Average Estimated proba when actually a  review  ";;meanc(selif(p_inf_IOP,price_review_vec[2:T_max] .eq 1));
"Average Estimated proba when actually NO review  ";;meanc(selif(p_inf_IOP,price_review_vec[2:T_max] .eq 0));

                        /* CHANGE DIRECTORY/FILENAME AS APPROPRIATE BELOW */


format 15,4;
            
    screen off; // screen off when MONTE CARLO
    
    "***********  ASSESSING  CORRECT CLASSIFICATION OF PRICE REVIEWS  ************************";
	"True proportion of price reviews, with sd         ";;   meanc(price_review_vec[2:T_max])~stdc(price_review_vec[2:T_max]);
    "Estimated Marginal P(review) Probability, with sd ";;	(1-p_IOP_inf[1])~p_IOP_inf[2];
	 print;
    "************************************************************************************************";

    "Estimated Price Review  Function Parameters";
    "(Duration should matter)";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;IOP[rows(OP)+i,.];
    endfor;
    print;
    
    "PRICE CHANGE EQUATION Estimated '2nd Stage' Ordered Parameters";
    "(Duration should NOT matter conditionnal on review. Current P-star should matter)";
    
    for i (1,rows(OP),1);
	    $OP_vars[i];;IOP[i,.];
    endfor;
    print; 

   screen on; // when MONTE CARLO


BIG_SIGNIF_IOP=BIG_SIGNIF_IOP+( IOP[.,3] .ge 1.96 );

//Storing for this draw the True proportion of price reviews,and 2)Estimated one; and 3)stcking proba of price change
// (3x1)vector
v_prob_price_reviews=v_prob_price_reviews|(meanc(price_review_vec[2:T_max])~(1-p_IOP_inf[1]) )~meanc( abs(p_change)) ;
    
    
    print;
  
    
//endif;

endfor;//end loop over NREP


"PCT OF SIGNIF_IOP for CASE";;compteur;
BIG_SIGNIF_IOP=BIG_SIGNIF_IOP/NREP;

   "Estimated Price Review  Function Parameters";
    "(Duration should matter)";
    print;
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;BIG_SIGNIF_IOP[rows(OP)+i,.];
    endfor;
    print;
    

    
    "PRICE CHANGE EQUATION Estimated '2nd Stage' Ordered Parameters";
    "(Duration should NOT matter conditionnal on review. Current P-star should matter)";

 for i (1,rows(OP),1);
	    $OP_vars[i];;BIG_SIGNIF_IOP[i,.];
    endfor;
    print; 
    

//Storing significance for all cases
RESULT_BIG_SIGNIF_IOP[.,compteur ]=BIG_SIGNIF_IOP;

RESULT_PROBA_REVIEW[.,compteur]=meanc(v_prob_price_reviews);

RESULT_CASE[.,compteur]=compteur;
RESULT_THETA[.,compteur]=theta;
RESULT_PSI[.,compteur]=phsi;

//Storing significance for all cases

endfor;//end loop over ii
endfor;//end loop over jj


"********************************************************************************";
"********************************************************************************";

"                             SUMMARY TABLE ACROSS CASES";

"Case number: ";
RESULT_CASE;
" Value of Theta (pct)";
RESULT_THETA;
"Value of Psi (pct)";
RESULT_PSI;

"Avg Actual and Estimated Proba of Price Review -and proba of price change ";
RESULT_PROBA_REVIEW;

"Actual Ratio of non-pric-review to non-pric change";
 (1-RESULT_PROBA_REVIEW[1,.])./(1-RESULT_PROBA_REVIEW[3,.]);
"Estimated Ratio of non-pric-review to non-pric change";
 (1-RESULT_PROBA_REVIEW[2,.])./(1-RESULT_PROBA_REVIEW[3,.]);


    print;
"Estimated Price Review  Function Parameters";; "(Duration should matter)";

 
    for i (1,rows(x_up_vars),1);
	    $x_up_vars[i];;RESULT_BIG_SIGNIF_IOP[rows(OP)+i,.];
    endfor;
    print;
    
  
    "PRICE CHANGE EQUATION Estimated '2nd Stage' Ordered Parameters";; "(Duration should NOT matter conditionnal on review. Current P-star should matter)";

 for i (1,rows(OP),1);
	    $OP_vars[i];;RESULT_BIG_SIGNIF_IOP[i,.];
    endfor;
    print; 

endtime=timeutc;
 "Time elapsed (seconds)    ";;endtime-starttime;
 "Time elapsed (in minutes) ";;(endtime-starttime)/60;
  print;
output off;
closeall;

stop;
